let dotresizeReset = function() {
	dotw = dotsbgBody.width = window.innerWidth;
	doth = dotsbgBody.height = window.innerHeight;
}

const dotopts = { 
	particleColor: "rgb(231,237,243)",
	lineColor: "rgb(231,237,243)",
	particleAmount: 50,
	defaultSpeed: 1,
	variantSpeed: 1,
	defaultRadius: 7,
	variantRadius: 3,
	linkRadius: 200,
};

window.addEventListener("resize", function(){
	dotdeBouncer();
});

let dotdeBouncer = function() {
    clearTimeout(dottid);
    dottid = setTimeout(function() {
        dotresizeReset();
    }, dotdelay);
};

let dotcheckDistance = function(x1, y1, x2, y2){ 
	return Math.sqrt(Math.pow(x2 - x1, 2) + Math.pow(y2 - y1, 2));
};

let dotlinkPoints = function(dotpoint1, dothubs){ 
	for (let e = 0; e < dothubs.length; e++) {
		let dotdistance = dotcheckDistance(dotpoint1.x, dotpoint1.y, dothubs[e].x, dothubs[e].y);
		let dotopacity = 1 - dotdistance / dotopts.linkRadius;
		if (dotopacity > 0) { 
			dotdrawArea.lineWidth = 0.5;
			dotdrawArea.strokeStyle = `rgba(${dotrgb[0]}, ${dotrgb[1]}, ${dotrgb[2]}, ${dotopacity})`;
			dotdrawArea.beginPath();
			dotdrawArea.moveTo(dotpoint1.x, dotpoint1.y);
			dotdrawArea.lineTo(dothubs[e].x, dothubs[e].y);
			dotdrawArea.closePath();
			dotdrawArea.stroke();
		}
	}
}

dotParticle = function(aPos, bPos){ 
	this.x = Math.random() * dotw; 
	this.y = Math.random() * doth;
	this.speed = dotopts.defaultSpeed + Math.random() * dotopts.variantSpeed; 
	this.directionAngle = Math.floor(Math.random() * 360); 
	this.color = dotopts.particleColor;
	this.radius = dotopts.defaultRadius + Math.random() * dotopts. variantRadius; 
	this.vector = {
		x: Math.cos(this.directionAngle) * this.speed,
		y: Math.sin(this.directionAngle) * this.speed
	};
	this.update = function(){ 
		this.border(); 
		this.x += this.vector.x; 
		this.y += this.vector.y; 
	};
	this.border = function(){ 
		if (this.x >= dotw || this.x <= 0) { 
			this.vector.x *= -1;
		}
		if (this.y >= doth || this.y <= 0) {
			this.vector.y *= -1;
		}
		if (this.x > dotw) this.x = dotw;
		if (this.y > doth) this.y = doth;
		if (this.x < 0) this.x = 0;
		if (this.y < 0) this.y = 0;	
	};
	this.dotdraw = function(){ 
		dotdrawArea.beginPath();
		dotdrawArea.arc(this.x, this.y, this.radius, 0, Math.PI*2);
		dotdrawArea.closePath();
		dotdrawArea.fillStyle = this.color;
		dotdrawArea.fill();
	};
};

function dotsetup(){ 
	dotparticles = [];
	dotresizeReset();
	for (let e = 0; e < dotopts.particleAmount; e++){
		dotparticles.push( new dotParticle() );
	}
	window.requestAnimationFrame(dotloop);
}

function dotloop(){ 
	window.requestAnimationFrame(dotloop);
	dotdrawArea.clearRect(0,0,dotw,doth);
	for (let e = 0; e < dotparticles.length; e++){
		dotparticles[e].update();
		dotparticles[e].dotdraw();
	}
	for (let e = 0; e < dotparticles.length; e++){
		dotlinkPoints(dotparticles[e], dotparticles);
	}
}

const dotsbgBody = document.getElementById("dotsbg"),
dotdrawArea = dotsbgBody.getContext("2d");
let dotdelay = 200, dottid,
dotrgb = dotopts.lineColor.match(/\d+/g);
dotresizeReset();
dotsetup();